program SpaceControl;
uses
     crt,
     mcga_vs,
     k_math,
     mouse_u,
     multKey,
     mcga_fnt,
     K_time,
     math_unt,
     sGame,
     mcga_pal,
     sshipAI,
     scTypes;
var
  game:Ogame;
  ad_fnt,ad,framesPerS:word;
  FNT,VS:Pointer;
  i:integer;
  gameInit:RgameInitData;
  shipInit:RshipInitData;

  exit:boolean;
function AIEditor(ad_fnt,ad:word):boolean;
var
  AI:OShipAI;
  ch:char;
  input,output:integer;
  m:Omouse;
  minV,val:real;
  x,y:integer;

  inputNumber:integer;
begin
  inputNumber:=12;

  {AI.loadMat('space\1.mat');}
  AI.loadMat('space\my.nnm');
  AI.data.inputSpec[1]:=inEnemyDis;
  AI.data.inputSpec[2]:=inEnemyFdeg;
  AI.data.inputSpec[3]:=inEnemyDegDis;
  AI.data.inputSpec[4]:=inDisGrad;
  AI.data.inputSpec[5]:=inShotDis;
  AI.data.inputSpec[6]:=inShotDeg;
  AI.data.inputSpec[7]:=inShotDegDis;
  AI.data.inputSpec[8]:=inIsOnEdge;
  AI.data.inputSpec[9]:=inConst;

  {AI.data.inputSpec[10]:=inNull;
  AI.data.inputSpec[11]:=inNull;
  AI.data.inputSpec[12]:=inConst;}
  minV:=0;
  val:=5;
  input:=1;
  output:=1;
  repeat
     for x:=1 to inputNumber do
       if(abs(getPosXin(x)-m.x)+abs(getPosYin(x)-m.y)<10)and(m.b>0)then input:=x;
     for x:=1 to 8 do
       if(abs(getPosXout(x)-m.x)+abs(getPosYout(x)-m.y)<10)and(m.b>0)then output:=x;
    if keypressed then ch:=readkey
      else ch:=#0;

    if(key[75])and(minV>0)then minV:=minV-0.1;
    if key[77] then minV:=minV+0.1;

    if ch=#80 then Val:=Val-0.1;
    if ch=#72 then Val:=Val+0.1;
    if ch=#32 then val:=-val;
    if ch='.' then val:=val*2;
    if ch=',' then val:=val/2;
    if ch=#13 then AI.data.EvalMat[output,input]:=val;
    if ch=#8 then AI.data.EvalMat[output,input]:=0;
    if ch='c' then AI.ClearEvalMatrix(0);
    AI.display(input,output,minv,ad_fnt,ad);
    putnum(minV,1,1,180,5,1,90,ad_fnt,ad);
    putnum(Val,1,1,200,5,1,90,ad_fnt,ad);
    putnum(AI.data.EvalMat[output,input],1,1,10,5,1,150,ad_fnt,ad);
    m.refresh;
    m.display(60,ad);
    flipscreen(ad,vga);
{    delay(2);}
    m.del(ad);
  until(ch=#27)or(ch='e');
  AIEditor:= ch=#27;
  AI.saveMat('space\my.nnm');
{  AI.saveMat('space\backup4.nnm');}
end;

begin

  randomize;
  setmcga;
  ad_fnt:=load_font('fonts\normalfont.knf',FNT);
  ad:=getVs(VS);
  set_fire(1,4,0,pal);
  {for i:=1 to 16 do setpal(i,i*4-1,0,0);
  for i:=1 to 16 do setpal(i+16,63,i*4-1,0);
  for i:=1 to 16 do setpal(i+32,63,63,i*4-1);}
  for i:=1 to 16 do setpal(48+i,i*3,i*3,i*3);
  for i:=1 to 16 do setpal(64+i,i,i,i*3);
  for i:=1 to 16 do setpal(64+16+i,round(min(i*4,63)),round(min(i*4,63)),i);
  for i:=1 to 16 do setpal(64+32+i,round(min(i*4,63)),0,round(min(i*4,63)));
  for i:=1 to 16 do setpal(64+48+i,0,round(min(i*4,63)),0);
  for i:=1 to 16 do setpal(64+64+i,round(min(i*4,63)),0,0);
  for i:=1 to 16 do setpal(64+80+i,0,round(min(i*4,63)),round(min(i*4,63)));
  for i:=1 to 16 do setpal(64+96+i,round(min(i*4,63)),0,round(min(i*3,63)));
  repeat
  exit:=AIEditor(ad_fnt,ad);
  gameInit.numberOfShips:=5;

  gameInit.worldSizeX:=round(160*3.5);
  gameInit.worldSizeY:=round(100*3.5);
  game.open(ad_fnt,ad,gameInit);

  for i:=0 to gameInit.numberOfShips do
  begin
    shipInit.faction:= i mod 2;
    shipInit.shipClass:=(i mod 2)*6;
    shipInit.playerType:=bool2int(i=0);
    shipInit.posX:=-200+400*(i mod 2);
    shipInit.posY:=random(400)-200;

    game.openShip(i,shipInit);
  end;

  {gui.open('guis\test',ad_fnt);}
  cls(0,ad);
  HookKeyBoardInt;
  tic;
  repeat
{    putnum(MaxAvail,1,1,10,5,1,90,ad_fnt,vga);
    framesPerS:=FPS;}
{    putnum(framesPerS,1,1,10,20,1,90,ad_fnt,vga);}
    game.main(true);
  until(key[1])or(exit);
  i:=1;
  {for i:=0 to 1 do}
{  gui.kill;}
  game.kill;
  UnHookKeyBoardInt;
  until exit;
  freeVs(VS);
  close_font(FNT);
  settext;
  TextMode(CO80);
  clrscr;

end.