unit SCTypes;
interface
uses mcga_vs,K_sprite,crt;
Const
  FireColor = 16*3;
  MaxGuns = 20;
  MaxShotPro = 60;
  MaxNumShips = 20;
type
    EControlType = (CUp,CDown,CTurnR,CTurnL,CStrifeR,CStrifeL,CShot1,CShot2
  ,CEDie,CEExplode,CELowPower,CEwasHit,CEhitting,CETime,CENotTime,CEControlJam);

{  RCamera = record
    x,y:real;
    zoom:real;
    ScreenX,ScreenY:integer;
  end;}

  RImpectData = record
    force,
    demege,
    energy,
    control:real;
{    shild,
    armor,
    ...}
  end;

  RgameInitData = record

     mainShipIndex:byte; {the index of the ship to foucous on}
     numberOfShips:byte;
     worldSizeX,worldSizeY:Integer;
     worldLimitType:byte;{mod, borader ,extended border, bounciy border}

     {shotProfileSet: 1 ,2 ,3}
     {number of factions}
     {number of items..}
     {netural hazards}
     {number of planets}
     hendyKept:byte; {1 - 100}
     cameraType:byte;{self, auto, minimumDistance, centerOfmass...}
     defaltCameraZoom,minCameraZoom,maxCameraZoom:word;

  end;

  RshipInitData = record
    playerType, {humen,comuterNN,swticng comp....}
    AIindex,
    shipClass,
    faction:byte;  {zero is nutral}

    posX,posY:integer;
    heding:byte; {jumps of 6 degrees}

  end;

  star = record
     x,y:integer;
  end;

  Rworld = record
    sizeX,sizeY:integer;
    firction:real;
    modulu:boolean;
  end;




Procedure CameraPixel(camera:Rcamera;X,Y: real; Color: Byte;ad:word);
Procedure CameraZPixel(camera:Rcamera;Z:real;X,Y: Integer; Color: Byte;ad:word);
function CameraGetPixel(camera:Rcamera;X,Y: Integer;ad:word):byte;
Procedure CameraLine(camera:Rcamera;x1,y1,x2,y2:real;Color:byte;ad:word);
procedure CameraCircle(camera:Rcamera;oX,oY,rad:real;Color:byte;ad:word); {paints a circle}
{procedure CameraBall(camera:Rcamera;oX,oY,rad:real;Color:byte;ad:word); {paints a ball}
procedure CameraCircleOn(camera:Rcamera;oX,oY,rad:real;Color:integer;ad:word); {paints a circle}
Procedure CameraWaveLine(camera:Rcamera;x,y,deg,length,time:real;Color:byte;ad:word);
implementation
uses math_unt;

Procedure LimpixelOn(X,Y: Integer; Color: integer;ad:word);
begin
  if(ad = 0)or(X > 319)or(Y > 199)or(X < 0)or(Y < 0)then exit;
   mem[ad:y shl 8+y shl 6+x]:=mem[ad:y shl 8+y shl 6+x] + color;
End;

procedure CircleOn(oX,oY:integer;rad:real;Color:integer;ad:word); {paints a circle}
var
  lx,ly,x,y,i:integer;
begin
  if rad>0 then
  for i:=0 to round(rad*2*pi) do
  begin
    x:=round(rad*cos(i/rad));
    y:=round(rad*sin(i/rad));
    if(lx<>x)or(ly<>y) then
      limpixelOn(Ox+x,Oy+y,Color,ad);
    lx:=x;
    ly:=y
  end
end;

Procedure CameraWaveLine(camera:Rcamera;x,y,deg,length,time:real;Color:byte;ad:word);
var
  i:integer;
  rad,d:real;
begin
   x:=x/camera.zoom+160-camera.x;
   y:=y/camera.zoom+100-camera.y;
   for i:=0 to round(length*10) do
   begin
     rad:=i/10;
     d:=cos(rad+time)*rad/5;
     LimPixel(round(x+(cos(deg)*rad+d*sin(deg))/camera.zoom),round(y+(sin(deg)*rad-d*cos(deg))/camera.zoom),Color,ad);
   end;
end;

procedure CameraCircle(camera:Rcamera;oX,oY,rad:real;Color:byte;ad:word); {paints a circle}
begin
{  if color<FireColor then color:=round(color/max(camera.zoom,1));}
  oX:=oX/camera.zoom+160-camera.x;
  oY:=oY/camera.zoom+100-camera.y;
  circle(round(oX),round(oY),rad/camera.zoom,color,ad);
end;

procedure CameraCircleOn(camera:Rcamera;oX,oY,rad:real;Color:integer;ad:word); {paints a circle}
begin
{  if color<FireColor then color:=round(color/max(camera.zoom,1));}
  oX:=oX/camera.zoom+160-camera.x;
  oY:=oY/camera.zoom+100-camera.y;
  circleOn(round(oX),round(oY),rad/camera.zoom,color,ad);
end;

Procedure CameraLine(camera:Rcamera;x1,y1,x2,y2:real;Color:byte;ad:word);
begin
{   if color<FireColor then color:=round(color/max(camera.zoom,1));}
   x1:=(x1)/camera.zoom+160-camera.x;
   y1:=(y1)/camera.zoom+100-camera.y;
   x2:=(x2)/camera.zoom+160-camera.x;
   y2:=(y2)/camera.zoom+100-camera.y;
   Line(round(x1),round(y1),round(x2),round(y2),Color,ad);
end;

procedure Circle(oX,oY,rad:integer;Color:byte;ad:word); {paints a circle}
var
  i:integer;
begin
  if rad>0 then
  for i:=0 to round(rad*2*pi) do
  limpixel(Ox+round(rad*cos(i/rad)),Oy+round(rad*sin(i/rad)),Color,ad);
end;

Procedure CameraZPixel(camera:Rcamera;Z:real;X,Y: Integer; Color: Byte;ad:word);
begin
  x:=round(x/camera.zoom*z-camera.x*z)+160;
  y:=round(y/camera.zoom*z-camera.y*z)+100;
  if(ad = 0)or(X > 319)or(Y > 199)or(X < 0)or(Y < 0)then exit;
{  if color<FireColor then color:=round(color/max(camera.zoom,1));}
  mem[ad:y shl 8+y shl 6+x]:=color;
End;

Procedure CameraPixel(camera:Rcamera;X,Y: real; Color: Byte;ad:word);
begin
  x:=x/camera.zoom-camera.x+160;
  y:=y/camera.zoom-camera.y+100;
  if(ad = 0)or(X > 319)or(Y > 199)or(X < 0)or(Y < 0)then exit;
{  if color<FireColor then color:=round(color/max(camera.zoom,1));}
  mem[ad:round(y) shl 8+round(y) shl 6+round(x)]:=color;
End;

function CameraGetPixel(camera:Rcamera;X,Y: Integer;ad:word):byte;
begin
  x:=round((x-camera.x)/camera.zoom)+160;
  y:=round((y-camera.y)/camera.zoom)+100;
  if(ad = 0)or(X > 319)or(Y > 199)or(X < 0)or(Y < 0)then
  begin
    CameraGetPixel:=0;
    exit;
  end;
  CameraGetPixel:=mem[ad:y shl 8+y shl 6+x];
End;
begin
end.