{$N+}
unit SShip;
interface
uses sshot,sshotpro,crt,mouse_u,sgun,sEngine,scTypes,sshipAI,K_Sprite,mcga_fnt;

  Const
    MaxEngines = 10;
type
  Rship = object
     numOfShots,numOfEngines,numOfGuns:byte;
     {Profile}
     maxPower,maxEnergy,maxControlJam:word;
     mass,moment:word;
     size:byte;
     powerGen,energyGen,controlGen:real;
     displayType:byte;
     GunsRedayDisp:array[1..5]of byte;
  end;

  Oship = object
  private
{     name:string[30];}
     sprite:Osprite;
     s:Rship;

     maxSpeed:real;
     color:byte;

     x,y,vx,vy,deg:real;
     shots:Oshots;
     Power:real;


     timeSinceDeath:word;

     PlayerType:byte;
     Input:word;

     demegeRecived:real;

    public
      energy:real;
      controlJam:real;

      Engines:array[1..MaxEngines]of Oengine; {**}
      Guns:array[1..MaxGuns]of Ogun; {**}{dynamicly alocate}
      ShipAI:OshipAI;
      constructor Cnew(var initData:RshipInitData);
      destructor kill;
      procedure SetProfiles(pro:POshotsProfile;ind:byte);
      procedure update;
      procedure updateShots;
      procedure display(PlayerInd:byte;camera:Rcamera;ad:word);
      procedure displayShots(camera:Rcamera;ad:word);
      procedure InfoDisplay(camera:Rcamera;i:byte;ad_fnt,ad:word);
      procedure del(player:byte;ad2,ad:word);
      procedure Control(myInd:byte;time,ad_fnt,ad:word);
      procedure ApplyImpect(fx,fy:real;impSpec:RImpectData);
      function ImpectCheck(Ex,Ey,Esize:real;var fx,fy,EsX,EsY,shotDis:real;var impSpec:RimpectData):real;
      function getDeathTime:word;
      function getLife:boolean;
      function getX:real;
      function getY:real;
      procedure setX(inx:real);
      procedure setY(iny:real);
      function getVX:real;
      function getVY:real;
      procedure Save(num:word);
      Procedure Load(num:word);
      function getSize:byte;
   end;
   POship = ^Oship;
implementation
uses space_u,multKey,K_math,math_unt,mcga_vs{,mcga_fnt},mcga_fil;

  function Oship.getDeathTime:word;
  begin
    getDeathTime:=timeSinceDeath;
  end;

  function Oship.getSize:byte;
  begin
    getSize:=s.size;
  end;


  constructor Oship.Cnew(var initData:RshipInitData);
  var
    i:integer;
  begin
     if initData.ShipClass =6 then
       s.numOfGuns:=10
     else
       s.numOfGuns:=9;

     s.numOfEngines:=5;

     s.maxPower:=200;
     s.maxEnergy:=200;
     s.maxControlJam:=400;

     s.mass:=1;
     s.moment:=20;
     timeSinceDeath:=0;

     s.size:=10;
     s.powerGen:=0;
     s.energyGen:=1;
     s.controlGen:=1;
     s.displayType:=0;
{     color:=0;}
     x:=0;
     y:=0;
     vx:=0;
     vy:=0;
     deg:=0;



     Power:=s.maxPower;
     energy:=0;


     PlayerType:=0;
     Input:=0;

     demegeRecived:=0;

     shots.Cnew;
     for i:=1 to 5 do
       s.GunsRedayDisp[i]:=0;
     s.GunsRedayDisp[1]:=4;
     s.GunsRedayDisp[2]:=7;

     for i:=1 to s.numOfEngines do
       engines[i].Cnew;
     for i:=1 to s.numOfGuns do
     begin
       guns[i].Cnew(i);
       SetProfiles(guns[i].getShotProfile,MaxShotPro+i)
     end;

     ShipAI.Cnew;

{     shipAI.setFaction(random(2));}

     {to do: replace with load image}


{     playertype:=inPlayerType;
{    color:=inColor;}
 {   x:=random(200);
    y:=0;
    deg:=random(1000)/500*pi;
    MaxPower:=250;
    MaxEnergy:=250;
    power:=MaxPower;
    life:=true;
    shipAI.setFaction(inFaction);
}

     playerType:=initData.playerType; {humen,comuterNN,swticng comp....}
     {initData.AIindex;}
{     initData.shipClass;}
     shipAI.setFaction(initData.faction);
     s.size:=10;
     if initData.faction=1 then  {remove}
     begin
       maxSpeed:=1.5;
       s.size:=7
     end
     else
       maxSpeed:=1.6;

     x:=initData.posX;
     y:=initData.posY;
     deg:=initData.heding/50*pi;

    load(initData.shipClass);
    guns[1].InitSmoke;
    guns[2].Init2;
    guns[3].InitExplotion;
    guns[4].initRound;
    guns[5].initLaser;
    guns[6].InitGettingHit;
    guns[7].InitTurbo;
    guns[8].InitShild;
    guns[9].InitControlJam;
    guns[10].InitEng;
    engines[1].initForward;



{    sprite.open(19,25);
    sprite.temp2;
    sprite.s.rotateSize:=13;}

    {1-normal}
    {2-borg}
    {3- big Borg cube}
    {4- big Borg sphere}
    {5 - very big sphere}

{    save(6);}

    energy:=1;
    controlJam:=0;

{    if initData.faction=0 then}
      shipAI.loadMat('space\my.nnm');
{    else
    shipAI.loadMat('space\backup3.nnm')}
   {sprite.load(stadd('space\ship',initData.shipClass,'\')+'\sprite');}
   sprite.open(46,45);
   sprite.temp2;
   sprite.s.rotateSize:=25;
  end;

  procedure Oship.Save(num:word);
  var
    i:integer;
    path:string;
  begin
    path:=stadd('space\ship',num,'\');
    sprite.save(path+'\sprite');
    for i:=1 to s.numOfEngines do
      engines[i].Save(stadd(path+'engines\engine',i,'.eng'));
    for i:=1 to s.numOfGuns do
      Guns[i].Save(stadd(path+'guns\gun',i,'.gun'));
  end;

  procedure Oship.Load(num:word);
  var
    i:integer;
    path:string;
  begin
{    shipAI.loadMat(stadd('space\',1,'.mat'));}
{    shipAI.loadMat('space\my.nnm');}
    path:=stadd('space\ship',num,'\');
    for i:=1 to s.numOfEngines do
      engines[i].Load(stadd(path+'Engines\engine',i,'.eng'));
    for i:=1 to s.numOfGuns do
       guns[i].init;
{      Guns[i].Load(stadd(path+'guns\gun',i,'.gun'));}
  end;

  procedure Oship.ApplyImpect(fx,fy:real;impSpec:RImpectData);
  begin
    vx:=vx+fx/s.mass; {/mass}
    vy:=vy+fy/s.mass;
    power:=min(power-impSpec.demege,s.maxPower);
    energy:=max(min(energy-impSpec.energy,s.maxEnergy),0);
    controlJam:=max(min(controlJam+impSpec.control,s.maxControlJam),0);
    demegeRecived:=demegeRecived + impSpec.demege; {******}
  end;

  function Oship.ImpectCheck(Ex,Ey,Esize:real;var fx,fy,EsX,EsY,shotDis:real;var impSpec:RimpectData):real;
  begin
    ImpectCheck:=shots.impectCheck(Ex,Ey,Esize,
    fx,fy,EsX,EsY,shotDis,impSpec);
  end;

  function Oship.getLife:boolean;
  begin
    getLife:=Power>0;
    {life; {chane to add not physyical pisebility}
  end;

  procedure Oship.InfoDisplay(camera:Rcamera;i:byte;ad_fnt,ad:word);
  var
    j:integer;
    t:real;
  begin
    {add map, direction indecator, faction indecator,}
    if getLife then
    begin
      if i=0 then
      begin
{        putnum(shipAI.enemyInd,1,1,50,5,1,90,ad_fnt,ad);}
        for j:=1 to 5 do
        begin
          if(s.GunsRedayDisp[j]>0)then
            if guns[s.GunsRedayDisp[j]].shotReady(energy) then
              FastBall(j*8+13,7,3,87-16,2,ad)
            else {add yellow for energy shortege}
              FastBall(j*8+13,7,3,87+16*3,2,ad)
        end;

      end;

      for j:=0 to 15 do
      begin
        line(j+(i div 2)*300+1,(i mod 2)*180+5, {to change from line to ver line}
          j+(i div 2)*300+1,(i mod 2)*180+5+5,
        round((max(power/s.maxPower,0)*j))+16*4+1,ad);
        line(j+(i div 2)*300+1,(i mod 2)*180+5+7,
          j+(i div 2)*300+1,(i mod 2)*180+5+5+6,
        round((max(energy/s.maxEnergy,0)*j))+16*5+1,ad);
{        putnum(demegeRecived,1,1,i*20+5,5,1,90,ad_fnt,ad);
        putnum(sqrt(sqr(Vx)+sqr(Vy)),1,1,i*20+20,190,1,90,ad_fnt,ad);}
      end;
    end;
  end;



  procedure Oship.displayShots(camera:Rcamera;ad:word);
  begin
    shots.display(camera,ad);
  end;

  procedure OShip.SetProfiles(pro:POshotsProfile;ind:byte);
  begin
      shots.SetProfiles(pro,ind);
  end;

  procedure Oship.control(myInd:byte;time,ad_fnt,ad:word);
  var
    i,ShotNum,ShotInd:integer;
    fx,fy,fDeg:real;
    impSelfSpec:RimpectData;
    temp:real;
  begin
    if getLife then
    begin
      input:=shipAI.evalControl(deg,x,y,playerType,time,ad_fnt,ad);
      if controlJam>0 then input:=0;
      shipAI.update(myInd,x,y); {chack if shot dis is ok}
    end
      else
        input:=0;

      {ExtraControl - possibly add more}
      Input:=setBit(input,ord(CEDie),(power<=0) and (timeSinceDeath<3));
      if(power<=0)and(timeSinceDeath<6000)then
           inc(timeSinceDeath);
      if(power/s.maxPower<0.3)and(getLife)then Input:=addBit(input,ord(CELowPower));
      if (time div 5) mod 2=0 then
        Input:=addBit(input,ord(CETime))
      else
        Input:=addBit(input,ord(CENotTime));;

      Input:=setBit(input,ord(CEControlJam),ControlJam>0);
      Input:=setBit(input,ord(CEwasHit),demegeRecived>0);

      {CEhitting}
      {CEExplode}

    {change to actice}
    if getLife then
    begin
      {engine part}
      fx:=0;
      fy:=0;
      fDeg:=0;
      temp:=sqrt(sqr(Vx)+sqr(Vy));
      for i:=1 to s.numOfEngines do
      if engines[i].isActive(input) then
      begin
        fx:=0; fy:=0;
        engines[i].applyForce(deg,fx,fy,fDeg);
        vx:=vx+fx/s.mass; {/mass   ------ move to update}
        vy:=vy+fy/s.mass; {/mass}
        if(sqrt(sqr(Vx)+sqr(Vy))>MaxSpeed)then
        begin
          Vx:=Vx/sqrt(sqr(Vx)+sqr(Vy))*max(temp,MaxSpeed);
          Vy:=Vy/sqrt(sqr(Vx)+sqr(Vy))*max(temp,MaxSpeed);
        end;
        {***************************}
      end;
      deg:=deg+fdeg/s.moment; {/moment}
    end;

      {guns part}
      fx:=0; fy:=0;
      for i:=1 to s.numOfGuns do {gun part}
      if(guns[i].isActive(input,Energy,getLife))then
      begin
        ShotInd:=0;
        ShotNum:=0;
        repeat
          shotInd:=ShotInd+1;
          if(shots.getPro(ShotInd)=0)then
          begin
            ShotNum:=ShotNum+1;
            guns[i].GunHasShot;
            fdeg:=guns[i].getInitDeg(deg);
            {shloud be init shot gun}
            shots.initShotGun(ShotInd,guns[i].getInitType,guns[i].getInitLife,
              guns[i].getInitX(x,deg),guns[i].getInitY(y,deg),fdeg);

            guns[i].getSelfForce(fdeg,fx,fy);
          end;
        until(shotInd=maxShots)or(guns[i].allShotsFired); {?to change}
        energy:=energy-guns[i].getEnergyNeed;
        guns[i].getSelfImpect(impSelfSpec);
        ApplyImpect(-fx,-fy,impSelfSpec);
      end;
  end;

  procedure Oship.del(player:byte;ad2,ad:word);
  begin
{     delpic(round(lx),round(ly),ldeg+pi/2,ad2,ad);
     delpic(round(posx),round(posy),deg+pi/2,ad2,ad);}
  end;

  procedure Oship.display(PlayerInd:byte;camera:Rcamera;ad:word);
  var
    i,k:integer;
  begin
    if getLife then
    for i:=1 to s.numOfEngines do
      engines[i].display(input,x,y,deg,camera,ad);
    sprite.CameraDisplayRot(camera,x,y,deg+pi/2,s.size,color,ad);
    {sprite.CameraDisplay(camera,x,y,size,color,ad);}

{     cameraLine(camera,x,y,x+cos(deg)*10,y+sin(deg)*10,90,ad);}
{     cameraCircle(camera,x,y,size,90,ad);}
{     putBall(camera,x,y,size/16,16*5+Color,ad);}


{     if(PlayerInd=0)then
     begin
       cameraCircle(camera,shipAI.getEnemyX,shipAI.getEnemyY,20*2,16*8+5,ad);
       cameraCircle(camera,shipAI.getAllieX,shipAI.getAllieY,10*1.5,16*5,ad);
       cameraCircle(camera,shipAI.getEshotX,shipAI.getEshotY,5*1.5,16*10,ad);
     end;}
  end;

  procedure Oship.updateShots;
  begin
                {EposX,EposY,SelfX,SelfY,FrendlyX,FrendliyY}
    shots.update(shipAI.getEnemyX,shipAI.getEnemyY
    ,shipAI.getAllieX,shipAI.getAllieY,x,y);
  end;

  procedure Oship.update;
  var
    i,num:integer;
  begin

{    if life then Change to Physical
    begin}
      for i:=1 to s.numOfGuns do
        guns[i].update;
      {?engines update...}

      {change to generators}
      if energy<s.MaxEnergy then energy:=energy+s.energyGen; {max(min}
      if power<s.MaxPower then power:=power+s.powerGen; {max(min}
      if controlJam>0 then controlJam:=max(ControlJam-s.ControlGen,0);

      if demegeRecived>0 then demegeRecived:=max(demegeRecived-0.5,0);{max(..,0)}

      Vx:=0.98*Vx; {change to areodynamics}
      Vy:=0.98*Vy;

      x:=x+Vx;
      y:=y+Vy;
{    end;}
  end;

  destructor Oship.kill;
  begin
    sprite.kill;
    shots.kill;
  end;


  function Oship.getX:real;
  begin
     getX:=x;
  end;

  function Oship.getY:real;
  begin
     getY:=y;
  end;

  procedure Oship.setX(inX:real);
  begin
    x:=inX;
  end;

  procedure Oship.setY(inY:real);
  begin
    Y:=inY;
  end;

  function Oship.getVX:real;
  begin
     getVX:=vx;
  end;

  function Oship.getVY:real;
  begin
     getVY:=vy;
  end;

begin
end.