
unit math_unt;
interface
  function bool2int(a:boolean):byte;
  function f_cont(a:real):real;
  function f_not(a:real):real;
  function f_and(a,b:real):real;
  function f_or(a,b:real):real;
  function f_to_l(a:real):boolean;
  function Grand(range:word):word;
  function no_deg(select:byte;x,y:real):real;
  function sign2byte(num:integer):byte;
  function byte2sign(num:byte):integer;
  {}
  function Word2int(num:word):integer;
  {}
  function Int2word(num:integer):word;
  procedure flipNum(var x,y:integer);
  {if Xmin>Xmax flips Xmin&Xmax and return 1,else return 0}
  function flip_only(var xmin,xmax:integer):byte;
  {returns 1 if A>B else returns 0}
  function AbigrB(A,B:real):byte;
  {transfers from 2 point to center point and radius}
  procedure PPtoRad(var x1,y1,x2r,y2r:integer);
  {returns the biger number from x1,x2}
  function max(x1,x2:real):real;
  {returns the smaler number from x1,x2}
  function min(x1,x2:real):real;
  {difrent metrics 0-sqrd oclidan,1-oqlidian,2-kings dist...}
  function no_dis(select:byte;x,y:real):real;
  procedure MathSetDeg(adeg:real);
  function  MathGetDeg:real;
  {returns X in the power of y}
  function XnY(xn,y:byte):word; {returns X in the power of y}
  function Pow(x:real;p:integer):real;
  {returns the ArcSin of an argumant}
  function ArcSin(x:real):real;
  {returns the ArcCin of an argumant}
  function ArcCos(x:real):real;
  {a linar Sin thet as a T of 4}
  function LinSin(x:real):real;
  {a linar Cos thet as a T of 4}
  function LinCos(x:real):real;
  {returns -1 if the input is negitive 0 for 0 and 1 for positive}
  function sign(num:real):integer;
  {reterns the degre in radians of point xm,ym reletive to 0,0}
  function GetDeg(xm,ym:real):real;
  {retrns a value asulting for amp to -amp linarliy}
  function zig(time,amp:integer):integer;
  {returns a value asulating from 0 to amp linarliy}
  function abszig(time,amp:integer):integer;
  {}
  function n_r(st,fin,num:integer):integer;
  function btb(num,bitn:byte):boolean;{returns true if bit number bitn is true}
  function baddb(num,bitn:byte):byte;
  function bsubb(num,bitn:byte):byte;
  function BCntB(num:byte):byte;
  function randnum(znum,cnum:word):word;
  function nrand(znum,cnum:word):integer;
  function randReal(cnum:real):real;

implementation
var
  deg:real;
   function bool2int(a:boolean):byte;
   begin
     if a=true then bool2int:=1
     else bool2int:=0;
   end;

   function randReal(cnum:real):real;
   begin
     randReal:=sin(cnum*cos(cnum*101))/2+0.5;
   end;

   function randnum(znum,cnum:word):word;
   begin
     randnum:=round(sin(cnum*cos(cnum*101))*znum/2+znum/2);
   end;

   function nrand(znum,cnum:word):integer;
   begin
     nrand:=round(sin(cnum*cos(cnum*101))*znum);
   end;

  procedure MathSetDeg(adeg:real);
  begin
    deg:=adeg;
  end;

  function MathGetDeg:real;
  begin
    MathGetDeg:=deg;
  end;

  function Grand(range:word):word;
  var
    i,ans:word;
  begin
    ans:=0;
    for i:=1 to range do
      ans:=ans+random(2);
    Grand:=ans;
  end;
  function f_cont(a:real):real;
  begin
    f_cont:=max(min(a,1),0);
  end;
  function f_not(a:real):real;
  begin
     f_not:=1-a;
  end;
  function f_and(a,b:real):real;
  begin
     f_and:=min(a,b);
  end;
  function f_or(a,b:real):real;
  begin
    f_or:=max(a,b);
  end;
  function f_to_l(a:real):boolean;
  begin
{     f_to_l:=a>=0.5;}
     f_to_l:=random(65500)<a*65500;
  end;

  function no_deg(select:byte;x,y:real):real;
  begin
    no_deg:=0;
    case select of
      {0:no_deg:=0;}
      1:no_deg:=1;
      2:no_deg:=AbigrB(x,y)*2-1;
      3:no_deg:=sin(getdeg(x,y)+3*pi/4);
      4:no_deg:=sin(x)*sin(y);
      5:no_deg:=AbigrB(-x,y)*2-1;
      6:no_deg:=AbigrB(x,-y)*2-1;
      7:no_deg:=AbigrB(-x,-y)*2-1;
      8:no_deg:=sin(getdeg(x,y)+2*pi/4);
      9:no_deg:=sin(getdeg(x,y)+pi/4);
      10:no_deg:=sin(getdeg(x,y));
      11:no_deg:=cos(2*getdeg(x,y)-3*pi/4);
    end;
  end;

  function byte2sign(num:byte):integer;
  begin
    byte2sign:=num-128;
  end;

  function sign2byte(num:integer):byte;
  begin
    sign2byte:=num+128;
  end;

  function Rmod(r,d:real):real;
  var
    i:integer;
  begin
    i:=0;
    repeat
      i:=i+1;
    until abs(r)-abs(i*d)<0;
    rmod:=(abs(r)-abs((i-1)*d))*sign(r*d);
  end;

  function Rdiv(r,d:real):integer;
  var
    i:integer;
  begin
    i:=0;
    repeat
      i:=i+1;
    until abs(r)-abs(i*d)<0;
    Rdiv:=(i-1)*sign(r*d);
  end;

  function Word2int(num:word):integer;
  begin
    Word2int:=num-32768;
  end;

  function Int2word(num:integer):word;
  begin
    Int2word:=num+32768;
  end;

  procedure flipNum(var x,y:integer);
  var
    temp:integer;
  begin
    temp:=x;
    x:=y;
    y:=temp;
  end;

  function flip_only(var xmin,xmax:integer):byte;
  var
    temp:integer;
  begin
    if xmin>xmax then
    begin
      temp:=xmin;
      xmin:=xmax;
      xmax:=temp;
      flip_only:=1;
    end
    else
      flip_only:=0;
  end;

  function AbigrB(A,B:real):byte;
  begin
    if A>B then AbigrB:=1
    else AbigrB:=0;
  end;

  procedure PPtoRad(var x1,y1,x2r,y2r:integer);
  var
    Xmid,Ymid:integer;
  begin
    Xmid:=round((x1+x2r)/2);
    Ymid:=round((y1+y2r)/2);
    x2r:=abs(x2r-Xmid);
    y2r:=abs(y2r-ymid);
    x1:=Xmid;
    y1:=Ymid;
  end;

  function max(x1,x2:real):real;
  begin
    if x1>x2 then max:=x1
    else max:=x2;
  end;

  function min(x1,x2:real):real;
  begin
    if x1<x2 then min:=x1
    else min:=x2;
  end;



  function XnY(xn,y:byte):word; {returns X in the power of y}
    var
      i:byte;
      temp:word;
  begin
    temp:=1;
    for i:=1 to y do temp:=temp*xn;
      XnY:=temp;
  end;

  function Pow(x:real;p:integer):real;
    var
      i:integer;
      temp:real;
  begin
    temp:=1;
    for i:=1 to p do temp:=temp*x;
      Pow:=temp;
  end;

  function ArcSin(x:real):real;
  begin
    ArcSin:= ArcTan (x/sqrt (1-sqr (x)));
  end;
  function ArcCos(x:real):real;
  begin
    ArcCos:= ArcTan (sqrt (1-sqr (x)) /x);
  end;
  function LinSin(x:real):real;
  begin
    LinSin:=2/pi*arcsin(sin(x*pi/2));
  end;
  function LinCos(x:real):real;
  begin
    Lincos:=2/pi*arcsin(cos(x*pi/2));
  end;

  function sign(num:real):integer;
  begin
    if num>0 then sign:=1
     else if num<0 then sign:=-1
      else sign:=0;
  end;

  function GetDeg(xm,ym:real):real;
  begin
    GetDeg:=0;
    if xm>0 then
    getdeg:=arctan(ym/xm)+2*pi;
    if xm<0 then
    getdeg:=arctan(ym/xm)+pi;
    if(xm=0)and(ym>0)then getdeg:=pi/2;
    if(xm=0)and(ym<0)then getdeg:=3*pi/2;
  end;

  function zig(time,amp:integer):integer;
  begin
    zig:=abs(time mod (amp*4)-amp*2)-amp;
  end;

  function abszig(time,amp:integer):integer;
  begin
    abszig:=abs(time mod (amp*2)-amp);
  end;

  function n_r(st,fin,num:integer):integer;
   var
     X:integer;
  begin
    x:=num-(abs(fin-st)+1)*(num div (abs(fin-st)+1))+(abs(fin-st)+1)*2;
    n_r:=(X-st) mod( abs(fin-st)+1)+st;
  end;

  function real_div(x,y:real):integer;
  var
   i:integer;
  begin
    i:=0;
    while((abs(x)-abs(y)*i)>0)do
    begin
     inc(i);
    end;
    real_div:=(i)*sign(round(x*y));
  end;

  function real_mod(x,y:real):real; {*********}
  begin
  end;

    {Math function wich returns true if bit number 'bitn' is true in 'num'}
    function btb(num,bitn:byte):boolean;
    begin
      btb:=(num or (1 shl bitn)=num);
    end;

    function baddb(num,bitn:byte):byte;
    begin
      baddb:=(num or (1 shl bitn));
    end;

    function bsubb(num,bitn:byte):byte;
    begin
      bsubb:=(num and not(1 shl bitn));
    end;

    function BcntB(num:byte):byte;
    var
      i,ans:byte;
    begin
        ans:=0;
        for i:=0 to 7 do
        if(num or (1 shl i)=num)then inc(ans);
        BcntB:=ans;
    end;

  function no_dis(select:byte;x,y:real):real;
  begin
    if(abs(x)<=1)and(abs(y)<=1)then
    case select of
      0:no_dis:=max(abs(x),abs(y));{Kings distance}
      1:no_dis:=sqrt(sqr(x)+sqr(y));{oclidian distance}
      2:no_dis:=(abs(x)+abs(y));{TaxiCab Distance}
      3:no_dis:=sqrt(sqrt(sqr(sqr(x))+sqr(sqr(y))));{(x^4+y^4)^(1/4)}
      4:no_dis:=max(max(abs(x),abs(y)),(abs(x)+abs(y))/1.4142);{StopSign dist'}
      5:no_dis:=min(sqrt(2)*max(abs(x),abs(y)),abs(x)+abs(y));{Star dist'}
      6:no_dis:=min(max(abs(x*2),abs((y-0.3)*1.49))
      ,max(abs(x)-y,abs((y+0.5)*2)));
      7:no_dis:=no_dis(6,x,-y);
      8:no_dis:=no_dis(6,y,x);
      9:no_dis:=no_dis(6,y,-x);
      10:no_dis:=max(abs(x)+y/2+0.5,abs(y));
      11:no_dis:=no_dis(10,x,-y);
      12:no_dis:=no_dis(10,y,x);
      13:no_dis:=no_dis(10,y,-x);
      14:no_dis:=max(sqrt(abs(x*y*2)),max(abs(x),abs(y)));
      15:no_dis:=max(sqrt(abs(x*y*4)),max(abs(x),abs(y)));
      16:no_dis:=max(sqrt(abs(x)+sqr(y)),sqrt(sqr(x)+abs(y)));
      17:no_dis:=max(abs(x),abs(y*1.3+sin(x*5)*0.3));
      18:no_dis:=no_dis(17,x,-y);
      19:no_dis:=no_dis(17,y,x);
      20:no_dis:=no_dis(17,y,-x);

      21:no_dis:=max(max(abs(x),abs(y)),abs(x)+y);
      22:no_dis:=no_dis(21,x,-y);
      23:no_dis:=no_dis(21,y,x);
      24:no_dis:=no_dis(21,y,-x);

      25:no_dis:=min(sqrt(sqr(x*2)+sqr(y)),sqrt(sqr(x)+sqr(y*2)));


      26:no_dis:=sqrt(sqrt(sqr(sqr(x))+sqr(y)));
      27:no_dis:=sqrt(sqrt(sqr(x)+sqr(sqr(y))));

      28:no_dis:=sqrt(sqr(x)+abs(y));
      29:no_dis:=sqrt(abs(x)+sqr(y));

      30:no_dis:=(sqrt(sqr(x)+sqr(y))*(2+sin(3*getdeg(x,y)+deg)));
      31:no_dis:=no_dis(30,x,-y);
      32:no_dis:=sqrt(sqr(x)+sqr(y))*(2+cos(3*getdeg(x,y)+deg));
      33:no_dis:=no_dis(32,-x,y);

      34:no_dis:=(sqrt(sqr(x)+sqr(y))*(2+sin(4*getdeg(x,y)+deg)));
      35:no_dis:=no_dis(34,x,-y);
      36:no_dis:=sqrt(sqr(x)+sqr(y))*(2+cos(4*getdeg(x,y)+deg));

      37:no_dis:=(sqrt(sqr(x)+sqr(y))*(2-sin(5*getdeg(x,y)+deg)));
      38:no_dis:=no_dis(37,x,-y);
      39:no_dis:=sqrt(sqr(x)+sqr(y))*(2+cos(5*getdeg(x,y)+deg));
      40:no_dis:=no_dis(39,-x,y);

      41:no_dis:=sqrt(sqr(x/2.5)+sqr(y))+0.5+0.5*cos(2*getdeg(x/2.5,y));
      42:no_dis:=no_dis(41,y,x);

      43:no_dis:=sqrt(sqr(x)+sqr(y)+abs(x*y));
      44:no_dis:=sqrt(sqr(x)+sqr(y)+abs(4*x*y));
      45:no_dis:=sqrt(sqr(x/1.2)+sqr(y/1.2)+sqr((x-y)/1.2));
      46:no_dis:=no_dis(45,y,-x);

      47:no_dis:=sqrt(abs(sqr(x)+sqr(y)-abs(x*y*2)))*2;
      48:no_dis:=max(sqr(max(abs(x),abs(y))),sqrt(abs(sqr(x)+sqr(y)-abs(x*y*2)))*3);


      49:no_dis:=abs(max(abs(cos(getdeg(-y,x)*1.5+deg))+0.3,sqrt(sqr(x)+sqr(y))));
      50:no_dis:=no_dis(49,y,-x);

      51:no_dis:=max(max(abs(x),-y),sqrt(abs(y+sqr(x)))*2);
      52:no_dis:=no_dis(51,x,-y);
      53:no_dis:=no_dis(51,y,x);
      54:no_dis:=no_dis(51,y,-x);

      55:no_dis:=abs(x);
      56:no_dis:=abs(y);

      57:no_dis:=abs(y-1)/2+abs(x);
      58:no_dis:=abs(-y-1)/2+abs(x);

      59:no_dis:=max(sqr(x)+sqr(y),abs(cos((abs(x)+abs(y))*pi/1.36)*1.5));
      60:no_dis:=abs(cos(no_dis(0,x,y)*pi/1.4)*1.6);
      61:no_dis:=abs(cos(no_dis(1,x,y)*pi/1.4)*1.6);
      62:no_dis:=abs(cos(no_dis(3,x,y)*pi/1.4)*1.6);
      63:no_dis:=abs(cos(no_dis(4,x,y)*pi/1.4)*1.6);
      64:no_dis:=abs(cos(no_dis(5,x,y)*pi/1.4)*1.6);
      65:no_dis:=abs(cos(no_dis(90,x,y)*pi/1.4)*1.6);
      66:no_dis:=abs(cos(no_dis(89,x,y)*pi/1.4)*1.6);
      67:no_dis:=abs(cos(no_dis(43,x,y)*pi/1.4)*1.6);

      68:no_dis:=max(sqr(x)+sqr(y),abs(cos(no_dis(57,x,y)*pi/1.4)*1.6));
      69:no_dis:=no_dis(68,x,-y);
      70:no_dis:=no_dis(68,y,x);
      71:no_dis:=no_dis(68,y,-x);

      72:no_dis:=max(no_dis(22,x,y),abs(cos(no_dis(57,x,y)*pi/1.4)*1.6));
      73:no_dis:=no_dis(72,x,-y);
      74:no_dis:=no_dis(72,y,x);
      75:no_dis:=no_dis(72,y,-x);

      76:no_dis:=max(abs(x*x-y*y)*2,max(abs(x),abs(y)));

      77:if(y<>0)and(x<>0)then
          no_dis:=sqrt(max(x*x/abs(y),y*y/abs(x)))
        else
          no_dis:=(abs(y)+abs(x))*11;


      78:if(y<>0)and(x<>0)then
          no_dis:=sqrt(max(abs(x*x*x)/abs(y),abs(y*y*y)/abs(x)))
        else
          no_dis:=(abs(y)+abs(x))*5;

      79:if(y<>0)and(x<>0)then
          no_dis:=sqrt(max(x*x*x*x/abs(y),abs(y*y*y)/abs(x)))
        else
          no_dis:=(abs(y)+abs(x/1.5))*6;
      80:no_dis:=no_dis(79,y,x);


      81:if(y<>0)then
           no_dis:=sqrt(sqrt(abs(x*x*x)/abs(y)))
         else
           no_dis:=abs(x)*5;

      82:no_dis:=no_dis(81,y,x);

      83:no_dis:=min(min(no_dis(0,y*6+5,x*x),no_dis(0,y*6-5,x*x)),
                 no_dis(81,x*1.1,y*1.50));

      84:no_dis:=no_dis(83,y,x);


      85:if(y<>0)and(x<>0)then{flowr}
           no_dis:=(abs(x*x*x)/abs(y)+abs(y*y*y)/abs(x))/1.5
      else no_dis:=(abs(x)+abs(y))*6;

      86:if(y<>0)and(x<>0)then{butter}
           no_dis:=abs(abs(x*x*x)/abs(y)-abs(y*y*y)/abs(x))
           else no_dis:=(abs(x)+abs(y))*6;

      87:if(y<>0)and(x<>0)then{butter}
           no_dis:=(abs(abs(x)/abs(y)-abs(y)/abs(x)))/2
         else no_dis:=2;

      88:no_dis:=abs(max(abs(x),abs(y))-abs(x)-abs(y))*2;
      89:no_dis:=abs(no_dis(0,x,y)+abs(x)+abs(y))/2;

      90:no_dis:=abs(max(abs(x),abs(y))+sqrt(sqr(x)+sqr(y)))/2;
      91:no_dis:=sqrt(abs(sqr(x)+sqr(y)-abs(2*x*y)))+max(abs(x),abs(y));
      92:no_dis:=max(x*x+y*y,max(abs(x),abs(y)));
      93:no_dis:=abs(cos(sqrt(no_dis(92,x,y))*pi/1.4)*1.6);

      94:no_dis:=(sqrt(sqr(x)+sqr(-y+0.29))*(3-sin(getdeg(x*8,-y+0.29))))/2.5;
      95:no_dis:=no_dis(94,x,-y);
      96:no_dis:=no_dis(94,y,x);
      97:no_dis:=no_dis(94,y,-x);

      98:no_dis:=sqrt(x*X+y*y)+abs(cos(getdeg(x,y)*2.5+pi/4+deg))/2;
      99:no_dis:=sqrt(x*X+y*y)+abs(cos(getdeg(x,y)*3+deg))/2;
      100:no_dis:=sqrt(x*X+y*y)+abs(cos(getdeg(x,-y)*(1.5+deg)+pi/4))/2;

      101:no_dis:=max(sqrt(sqr(x)+sqr(y)),abs(cos(getdeg(x,y)*2+pi/4+deg))*1.5);
      102:no_dis:=max(max(abs(x),abs(y)),abs(cos(getdeg(x,y)*2+pi/4+deg))*1.5);
      103:no_dis:=max(abs(x)+abs(y),abs(cos(getdeg(x,y)*2+pi/4-deg))*1.5);

      104:no_dis:=max(abs(x)+abs(y),abs(cos(getdeg(x,y)*2+pi/4)));
      105:no_dis:=abs(cos(getdeg(x,y)*2+deg));

      106:no_dis:=sqrt(x*X+y*y)+abs(cos(getdeg(x,y)*100))/2;
      107:no_dis:=max(no_dis(12,-y,x),no_dis(39,-y,x));
      108:no_dis:=min(no_dis(12,y,x),no_dis(39,y,x));
      109:no_dis:=min(min(max(abs((x-0.7)*4),abs(y)),max(abs((x+0.7)*4),abs(y))),
      min(max(abs(x),abs((y-0.7)*4)),max(abs(x),abs((y+0.7)*4))));
      110:no_dis:=min(no_dis(61,x*2,y*2+1),no_dis(68,x*1.5,y*1.5-0.54));
      111:no_dis:=min(abs(cos(sqrt(x*x+abs(y))*pi+2.3)*1.6),
      no_dis(61,x*2.5,y*1.7));
      else
        if no_dis(select-111,x,y)<1 then
        no_dis:=abs(cos(no_dis(select-111,x,y)*pi/1.4)*1.6)
        else no_dis:=2;
    end
    else
    no_dis:=2;
  end;

begin
  deg:=0;
end.