unit SEngine;
interface
uses SCtypes,math_unt,k_sprite,space_u;
type

  EControlType = (CUp,CDown,CTurnR,CTurnL,CStrifeR,CStrifeL,CShot1,CShot2);
  Rengine = record
    size:integer;
    EnergyNeed:real;
    Force,DirDeg:real; {the force and heding of the engine}
    rad,deg:real; {the postion of the engine}
    ControlKeys:Word;

    {ControlKeysAnd}
{   maximumSpeed
    coolDown
    activeTime}

{    DisplayType}
  end;

  Oengine = object
    data:Rengine;
{    animationTime:Word;}

    constructor Cnew;
    procedure initForward;
{    procedure initLeft;
    procedure initRight;}
    procedure initLeftUp;
    procedure initLeftDown;
    procedure initRightUp;
    procedure initRightDown;
    function isActive(inKeys:word):boolean;
    procedure applyForce(inDeg:real;var fx,fy,fdeg:real);
    procedure display(InKeys:word;x,y,inDeg:real;camera:Rcamera;ad:word);
    procedure Load(fileName:string);
    procedure Save(fileName:string);

  end;
implementation
  uses mcga_vs,k_math;

  constructor Oengine.Cnew;
  begin
    data.size:=0;
    data.EnergyNeed:=0;
    data.Force:=0;
    data.DirDeg:=0;
    data.rad:=0;
    data.deg:=0;
    data.ControlKeys:=0;
  end;

  procedure Oengine.display(InKeys:word;x,y,inDeg:real;camera:Rcamera;ad:word);
  begin
    if isActive(InKeys) then
    begin
{      inc(animationTime);}
{      CameraLine(camera,round((x+data.rad*cos(data.deg+inDeg))),
      round((y+data.rad*sin(data.deg+inDeg))),
      round((x+data.rad*cos(data.deg+inDeg)+data.size*cos(data.DirDeg+indeg))),
      round((y+data.rad*sin(data.deg+inDeg)+data.size*sin(data.DirDeg+indeg)))
      ,90,ad);
      CameraCircle(camera,round((x+data.rad*cos(data.deg+inDeg)+data.size*cos(data.DirDeg+indeg))),
      round((y+data.rad*sin(data.deg+inDeg)+data.size*sin(data.DirDeg+indeg))),2,90,ad);
{      camerapixel(camera,(x+data.rad*cos(data.deg+inDeg)+data.size*cos(data.DirDeg+indeg)),
      (y+data.rad*sin(data.deg+inDeg)+data.size*sin(data.DirDeg+indeg)),40,ad);}

      cameraBall(camera,x+data.rad*cos(data.deg+inDeg),y+data.rad*sin(data.deg+inDeg),2/16,30,ad);
    end;
{      CameraWaveLine(camera,
      x+data.rad*cos(data.deg+inDeg),
      y+data.rad*sin(data.deg+inDeg),
      data.dirDeg+inDeg,14,animationTime/2,160,ad);}
  end;

  procedure Oengine.applyForce(inDeg:real;var fx,fy,fdeg:real);
  begin
     fDeg:=fDeg+data.Rad*data.force*sin(deg_diff(data.DirDeg,data.deg));
     fx:=fx-data.force*cos(data.dirDeg+indeg);
     fy:=fy-data.force*sin(data.dirDeg+indeg);
  end;

  function Oengine.isActive(inKeys:word):boolean;
  begin
      isActive:=(data.controlKeys and inKeys)>0;
  end;

  procedure Oengine.Load(fileName:string);
   var
    EngFile:File of Rengine;
  begin
{     animationTime:=random(1000);}
     Assign(EngFile,fileName);
     Reset(EngFile);
     read(EngFile,data);
     Close(EngFile);
  end;

  procedure Oengine.Save(fileName:string);
  var
    EngFile:File of Rengine;
  begin
     Assign(EngFile,fileName);
     Rewrite(EngFile);
     write(EngFile,data);
     Close(EngFile);
   end;

  procedure Oengine.initForward;
  begin
    data.ControlKeys:=AddBit(0,ord(CUp));
    data.size:=10;
    data.EnergyNeed:=0;
    data.Force:=0.1;
    data.DirDeg:=pi;
    data.rad:=6;
    data.deg:=pi;
  end;

  procedure Oengine.initLeftUp;
  begin
    data.size:=10;
    data.EnergyNeed:=0;
    data.Force:=0.1;
    data.DirDeg:=pi/2;
    data.rad:=7;
    data.deg:=pi/4;
    data.ControlKeys:=AddBit(0,ord(CStrifeL))+AddBit(0,ord(CTurnL));
  end;

  procedure Oengine.initLeftDown;
  begin
    data.size:=10;
    data.EnergyNeed:=0;
    data.Force:=0.1;
    data.DirDeg:=pi/2;
    data.rad:=7;
    data.deg:=pi/4+pi/2;
    data.ControlKeys:=AddBit(0,ord(CStrifeL))+AddBit(0,ord(CTurnR));
  end;

  procedure Oengine.initRightUp;
  begin
    data.size:=10;
    data.EnergyNeed:=0;
    data.Force:=0.1;
    data.DirDeg:=-pi/2;
    data.rad:=7;
    data.deg:=-pi/4;
    data.ControlKeys:=AddBit(0,ord(CStrifeR))+AddBit(0,ord(CTurnR));
  end;

  procedure Oengine.initRightDown;
  begin
    data.size:=10;
    data.EnergyNeed:=0;
    data.Force:=0.1;
    data.DirDeg:=-pi/2;
    data.rad:=7;
    data.deg:=-pi/4-pi/2;
    data.ControlKeys:=AddBit(0,ord(CStrifeR))+AddBit(0,ord(CTurnL));
  end;


  begin

  end.

