unit SGame;
interface
uses SShip
    ,SShotPro
    ,mouse_u
    ,multKey
    ,scTypes
    ,mcga_fil
    ,sshot,
    k_sprite,
    mcga_fnt,
    sstars,
    Scamera;

type

  Ogame = object
    private
    text:String; {***********}
    textTime:word;
    textIndex:word;
    ships:array[0..maxNumShips]of POship;
    shotP:array[1..maxShotPro]of OshotsProfile; {****}
    stars:Ostars;
    cameraControl:OCameraControl;
    camera:Rcamera;
    world:Rworld;

    ShipsNum:byte;

    CameraMode:boolean;

    mouse:Omouse;

    time:longint;
    ad_fnt,ad:word;

    DispControlFire,
    DispControlFlipScreen,
    DispControlClearScreen,
    DispControlShips,
    DispControlShots:integer;
    {slowmotion control}
{    idleTime,applyDelay:word;}
    cameraX,cameraY:real;

    public


    function open(in_ad_fnt,in_ad:word;gameInit:RgameInitData):boolean; {will get a text file spesefing all the}
    procedure openShip(shipInd:byte;var shipInitData:RshipInitData);
{    procedure KillShip}
    procedure kill;

    procedure updateText;
    function main(paint:boolean):boolean;
    procedure ClearScreen(smartClear:boolean);
    procedure DrawScreen;
    procedure update;
   { procedure CameraControl;}

    procedure WorldLimit;

    function GetWinner:byte; {returns faction of wining side}
    function exit:boolean;
{    function Greade(faction:byte)}
  end;

  implementation
  uses mcga_vs,space_u,math_unt{,mcga_fnt},crt,k_Math;

  procedure Ogame.kill;
  var
    shipInd:integer;
  begin
    for shipInd:=0 to ShipsNum do
      Dispose(ships[shipInd],kill);
  end;

  function Ogame.open(in_ad_fnt,in_ad:word;gameInit:RgameInitData):boolean;
  var
    shipInd,i:integer;
  begin
    ad:=in_ad;
    ad_fnt:=in_ad_fnt;

    shipsNum:=gameInit.numberOfShips;
    world.sizeX:=gameInit.worldSizeX;
    World.SizeY:=gameInit.worldSizeY;

    Camera.ScreenX:=320;
    Camera.ScreenY:=200;


    time:=0;
    {********************** Shot Profile ********************}
    for i:=1 to maxShotPro do
      shotP[i].initProfile3Normal;
{      shotP[i].load(stadd('space\ShotP',i,'.SSP'));}
    {*************************Enter Profiles *********}
    shotP[1].initProfile1;
    shotP[2].initProfile2;
    shotP[3].initProfile3Normal;
    shotP[10].initProfile10;
    shotP[11].initProfile11ExpBall;
    shotP[8].initProfile8;

{    for i:=1 to maxShotPro do
      shotP[i].save(stadd('space\ShotP',i,'.SSP'));}
    {******************** Display Parameters **********************}
    DispControlFire:=2;
    DispControlFlipScreen:=2;
    DispControlClearScreen:=2;
    DispControlShips:=2;
    DispControlShots:=1;
    {******************** Game Init ***************************}
{    idleTime:=0;
    applyDelay:=0;}
    time:=0;
    camera.Zoom:=1;
    stars.init(world.sizeX,world.sizeY);
    world.modulu:=true;
    cameraControl.Cnew(shipsNum);

  end;

  procedure Ogame.openShip(shipInd:byte;var shipInitData:RshipInitData);
  var
    i:integer;
  begin
    {******************** Ship Initlztion **********************}
      New(ships[shipInd],Cnew(shipInitData));
      for i:=1 to MaxShotPro do  {******}
        ships[shipInd]^.SetProfiles(@shotP[i],i);
      {temp}
      if shipInd=0 then ships[0]^.guns[7].SetControl(0,pow2(ord(cTurnL))+pow2(ord(cTurnR)));
  end;


  function Ogame.exit:boolean;
  var
    winner:word;
    i:byte;
  begin
    winner:=0;
    for i:=0 to ShipsNum do
       if ships[i]^.getLife then
         winner:=addbit(winner,ships[i]^.shipAI.getFaction);
    exit:=isPow2(winner);
  end;

  function Ogame.GetWinner:byte; {shlod return faction instad of ship index}
  var
    i:integer;
  begin
    i:=-1;
    repeat
      i:=i+1;
    until (ships[i]^.getLife)Or(i=ShipsNum);
    getWinner:=ships[i]^.ShipAI.getFaction;
  end;

  function Ogame.main(paint:boolean):boolean;
  begin
{    text:=' test';}

    time:=time+1;
    mouse.refresh;
    {- Clears the Screen}
    if(paint)and((DispControlClearScreen=1)or(time mod DispControlClearScreen=1))then
      ClearScreen(false);

{    TaskMeneger;{- selects ships Enemy and objective}

    update;     {- updates game logic}
    WorldLimit; {- confines ships to the world}

    if paint then
    begin
      CameraControl.update(ships,camera,world,mouse.b);
      updateText;
  {    if time mod Disp1=0 then}
        DrawScreen;
{      putnum(FPS,1,1,280,5,1,90,ad_fnt,ad);}
      if time mod DispControlFlipScreen=0 then
      begin
{        firebg(1,1,318,198,16*3,3,ad,ad);}
{        mouse.display(40,ad);}
        flipscreen(ad,vga);
{        mouse.del(ad);}
      end;
      if(DispControlFire=1)or(time mod DispControlFire=1)then
        firebg(1,1,318,198,16*3,3,ad,ad);{change fire color to const}
    end;
    main:=false;
  end;

  procedure Ogame.clearScreen(smartClear:boolean);
  var
    i,j:integer;
  begin
      for i:=0 to 319 do
      begin
        putpixel(i,0,0,ad);
        putpixel(i,199,0,ad);
      end;
      for i:=1 to 198 do
      begin
        putpixel(0,i,0,ad);
        putpixel(319,i,0,ad);
      end;

      for i:=1 to 318 do for j:=1 to 198 do
        if getpixel(i,j,ad)>FireColor then
          putpixel(i,j,0,ad);
  end;

  procedure Ogame.DrawScreen;
  var
    i:integer;
  begin
      if time mod DispControlShips=0 then
      begin
        stars.draw(camera,ad);
        { map - make const size, display only if asked}
        frame(40-round(world.sizeX/15),45-round(world.sizeY/15),
              40+round(world.sizeX/15),45+round(world.sizeY/15),90,ad);
        for i:=0 to shipsNum do
          FastBall(40+round(ships[i]^.getX/15),45+round(ships[i]^.getY/15)
          ,2,16*6+5+ships[i]^.shipAI.getFaction*16+bool2int(i=0)*5,2+bool2int(i=0)*2,ad);

        midtext(text,1,319,5,1,18,ad_fnt,ad);
        for i:=0 to round(min(ShipsNum,4)) do
        begin
          ships[i]^.infoDisplay(camera,i,ad_fnt,ad);
        end;

        for i:=0 to ShipsNum do
          ships[i]^.display(i,camera,ad);
      end;

      if time mod DispControlshots=0 then
      begin
        for i:=0 to ShipsNum do
          ships[i]^.displayShots(camera,ad);
      end;
  end;

  procedure Ogame.update;
  var
    impSpec:RimpectData;
    i,j,EnemyInd:integer;
    fx,fy,demege,dis,EsX,EsY:real;
  begin

    for i:=0 to ShipsNum do  {needs fine tunig for the order of things}
    begin
      ships[i]^.update;
      ships[i]^.Control(i,time,ad_fnt,ad);
      ships[i]^.updateShots;
    end;



    for i:=0 to shipsNum do {-cheking shot impect combine with task Meneger}
      for j:=1 to shipsNum do
      begin
        EnemyInd:=(i+j) mod (shipsNum+1);
        ships[i]^.shipAI.selectTarget(EnemyInd,ships[enemyInd]^.shipAI.getFaction,
          ships[EnemyInd]^.getX,ships[EnemyInd]^.getY,
          ships[EnemyInd]^.getVX,ships[EnemyInd]^.getVY,ships[enemyInd]^.getLife);

        {to do:?????}
        ships[i]^.ImpectCheck(ships[enemyInd]^.getX,ships[enemyInd]^.getY,ships[enemyInd]^.getSize,
          fx,fy,EsX,EsY,dis,impSpec);

        ships[EnemyInd]^.shipAI.selectEnemyShot(dis,EsX,EsY);
        ships[enemyInd]^.ApplyImpect(fx,fy,impSpec);
      end;
  end;

  procedure Ogame.WorldLimit; {move out to other file}
  var
    i:integer;
  begin
     for i:=0 to shipsNum do
     begin
      if world.modulu {chenge to Enum}then
      begin
        if ships[i]^.getX>world.SizeX then ships[i]^.setX(-world.SizeX);
        if ships[i]^.getX<-world.SizeX then ships[i]^.setX(world.SizeX);
        if ships[i]^.getY>world.SizeY then ships[i]^.setY(-world.SizeY);
        if ships[i]^.getY<-world.SizeY then ships[i]^.setY(world.SizeY);
      end
      else
      begin
        if ships[i]^.getX>world.SizeX then ships[i]^.setX(world.SizeX);
        if ships[i]^.getX<-world.SizeX then ships[i]^.setX(-world.SizeX);
        if ships[i]^.getY>world.SizeY then ships[i]^.setY(world.SizeY);
        if ships[i]^.getY<-world.SizeY then ships[i]^.setY(-world.SizeY);
      end;
    end;
  end;

  procedure Ogame.updateText;
  var
    i:integer;
  begin
    if textIndex<=8 then
    begin
    if TextIndex<8 then
    begin
      for i:=1 to ShipsNum do
        ships[i]^.ControlJam:=200;



      camera.zoom:=1;
      camera.x:=ships[0]^.getX/1;
      camera.y:=ships[0]^.getY/1;
    end;
    if textIndex=0 then
    begin
      case time of
        2:text:='Hello Captain, we arrived in sector 13h.';
        500:text:='Due to optical abnormalities everything looks crappy.';
        800:text:='Captain, Let''s go over the controls:';
        1000:begin
          text:='Press W to move Forward';
          textIndex:=1;
        end;
      end;
      if key[15] then
      begin
        TextIndex:=7;
        text:='You Skipped a Bit , Press S for the Doom Shot';
      end;
   end;


       if(textIndex=1)and(key[17])then
       begin
         text:='Press A or D to turn';
         inc(textIndex);
       end;

       if(textIndex=2)and((key[30])or(key[32]))then
       begin
         text:='Press A AND D to Sprint';
         inc(textIndex);
       end;

       if(textIndex=3)and((key[30])and(key[32]))then
       begin
         text:='Press Q or E to Strife';
         inc(textIndex);
       end;

       if(textIndex=4)and((key[16])or(key[18]))then
       begin
         text:='Press Tab to Fire';
         inc(textIndex);
       end;

       if(textIndex=5)and(key[15])then
       begin
         text:='Press Tilda~(on the left side of the keyborad)';
         inc(textIndex);
       end;

       if(textIndex=6)and(key[41])then
       begin
         text:='And last press S for the Doom Shot';
         inc(textIndex);
       end;

       if(key[31])and(TextIndex<8) then
       begin
          TextIndex:=8;
          text:='Get Ready..';
          TextTime:=200;
          ships[0]^.ControlJam:=200;
       end;

       if(textIndex=8)then
       begin
         texttime:=texttime-1;
         if texttime=50 then
         begin
           text:='Go.. Go.. Go..';
           for i:=0 to ShipsNum do
             ships[i]^.ControlJam:=0;
           for i:=1 to ShipsNum do
           ships[i]^.Energy:=10;

         end;
         if texttime=1 then
         begin
           text:='';
           inc(TextIndex);
         end;
       end;
    end;
  end;

begin
end.