{$A+ Align all data on word boundaries       }
{$B- Enable short circuit boolean evaluation }
{$D+ Enable debugging information            }
{$E- Disable x87 emmulation                  }
{$F- Do not force far calls                  }
{$G+ Enable 286 instructions                 }
{$I- Disable IO checking                     }
{$O- Disable overlay support                 }
{$Q- Disable overflow checking               }
{$R- Disable range checking                  }
{$S- Disable stack checking                  }
{$T- Disable type checking on pointers       }
{$V- Disable VAR type checking               }
{$X+ Enable Extended syntax                  }
{$Y- Disable symbol reference info           }
{$N+}
unit space_u;
interface
uses scTypes,k_sprite;
 var
  ss:array[-20..20,-20..20]of byte;
{(
(00,00,00,00,00,00,00,00,00,00,00),
(00,00,00,25,00,00,00,25,00,00,00),
(00,00,25,25,00,00,00,25,25,00,00),
(00,25,13,25,00,00,00,25,13,25,00),
(00,25,47,25,00,00,00,25,47,25,00),
(00,25,26,25,29,00,29,25,24,25,00),
(00,25,17,25,25,29,25,17,17,25,00),
(00,25,25,25,25,25,25,25,25,25,00),
(00,25,47,24,10,10,10,24,24,25,00),
(00,24,25,10,10,10,12,10,25,24,00),
(00,25,17,10,10,10,10,10,24,25,00),
(00,25,25,10,10,10,10,10,25,25,00),
(00,47,26,10,10,10,10,10,26,47,00),
(00,25,24,04,10,10,10,04,25,19,00),
(00,47,25,25,25,00,25,30,25,47,00),
(00,24,25,00,00,00,00,00,25,25,00),
(00,25,00,00,00,00,00,00,00,25,00),
(00,00,00,00,00,00,00,00,00,00,00));}

{ss2:array[-9..8,-5..5]of byte =
(
(00,00,00,00,00,00,00,00,00,00,00),
(00,00,00,00,00,00,00,00,00,00,00),
(00,00,00,00,00,00,00,00,00,00,00),
(00,00,00,00,00,00,00,00,00,00,00),
(00,00,00,00,25,25,25,00,00,00,00),
(00,00,25,25,29,29,29,25,25,00,00),
(00,25,17,25,29,29,29,17,17,25,00),
(00,25,25,25,25,25,25,25,25,25,00),
(25,25,47,24,10,10,10,24,24,25,25),
(25,24,25,10,10,10,12,10,25,24,25),
(25,25,17,10,10,10,10,10,24,25,25),
(00,25,25,10,10,10,10,10,25,25,00),
(00,47,26,10,10,10,10,10,26,47,00),
(00,25,24,24,25,25,25,24,25,19,00),
(00,47,25,25,00,00,00,30,25,47,00),
(00,24,25,00,00,00,00,00,25,25,00),
(00,25,00,00,00,00,00,00,00,25,00),
(00,00,00,00,00,00,00,00,00,00,00));}


  procedure firebg(xmin,ymin,xmax,ymax:integer;hic,lowc:byte;vaddr,ad2:word);
  procedure CameraCir(camera:Rcamera;x,y,rad:real;num:integer;deg:real;color:byte;ad:word);
{  procedure putpic(camera:Rcamera;xp,yp:real;deg,size:real;s,color:byte;ad:word);}
  procedure CameraBall(camera:Rcamera;xp,yp:real;size:real;color:byte;ad:word);
  procedure delpic(camera:Rcamera;xp,yp:real;deg,size:real;ad2,ad:word);
  procedure FastBall(xp,yp,size:integer;color:byte;colorGrad:real;ad:word);
  Procedure frame(x1,y1,x2,y2,col:integer;ad_vs:word);


implementation
  uses math_bgs,mcga_vs,math_unt;


  function getXY(x,y:integer):byte;
  begin
    if(abs(x)<=20)and(abs(y)<=20)then
      getXY:=ss[y,x]
    else
      getXY:=0;
  end;

  function setXY(x,y:integer;color:byte):byte;
  begin
    if(abs(x)<=20)and(abs(y)<=20)then
      ss[y,x]:=color
  end;

  {
procedure  putpic(camera:Rcamera;xp,yp:real;deg,size:real;s,color:byte;ad:word);
var
 x,y,lim:integer;
 indx,tx,indy,ty:integer;
 col:byte;
 de,rad:real;
begin

    xp:=round(xp/camera.zoom-camera.x)+160;
    yp:=round(yp/camera.zoom-camera.y)+100;
    lim:=round(20/size);

    for indX:=round(max(xp-lim,0)) to round(min(xp+lim,319)) do
    for indY:=round(max(yp-lim,0)) to round(min(yp+lim,199)) do
    begin
      x:=round(indX-xp);
      y:=round(indY-yp);
      De:=getdeg1(x,y);
      rad:=sqrt(sqr(y)+sqr(x))*size;

      col:=getxy(round(rad*cos(de-deg))
      ,round(rad*sin(de-deg)));
      if col>0 then
        LimPixel(round(xp+x),round(yp+y),col,ad);
    end;
end;}

procedure FastBall(xp,yp,size:integer;color:byte;colorGrad:real;ad:word);
var
  x,y:integer;
  rad:real;
begin
  for x:=-size+1 to size-1 do for y:=-size+1 to size-1 do
  begin
     rad:=getRad(x,y);
     if rad<size{-0.5} then
        putPixel(xp+x,yp+y,round(color-rad*colorGrad),ad)
  end
end;

procedure  CameraBall(camera:Rcamera;xp,yp:real;size:real;color:byte;ad:word);
var
     lim:integer;
     indx,tx,indy,ty:integer;
     x,y:real;
     col:byte;
begin
    xp:=xp/camera.zoom-camera.x+160; {change to screen}
    yp:=yp/camera.zoom-camera.y+100;
    lim:=round(16/camera.zoom*size);

    for indX:=round(max(xp-lim,0)) to round(min(xp+lim,319)) do
    for indY:=round(max(yp-lim,0)) to round(min(yp+lim,199)) do
    begin
      x:=indX-xp;
      y:=indY-yp;
      col:=round(max(16-getRad(round(x*camera.zoom/size),round(y*camera.zoom/size)),0));
{      col:=getColorCenter(round(size*x),round(size*y));}
      if col>0 then
        putPixel(round(xp+x),round(yp+y),col+color,ad)
{       else
        BugPixel(round(xp+x),round(yp+y),100,ad);}
    end;
  end;

procedure delpic(camera:Rcamera;xp,yp:real;deg,size:real;ad2,ad:word);
var
 x,y:integer;
 col:byte;
 de,rad:real;
begin
    xp:=(xp-camera.x)/camera.zoom+160;
    yp:=(yp-camera.y)/camera.zoom+100;
    for x:=-round(10/size) to round(10/size) do for y:=-round(10/size) to round(10/size) do
{    for x:=-10 to 10 do for y:=-10 to 10 do}
    begin
{      De:=getdeg1(x,y);
      rad:=sqrt(sqr(y)+sqr(x));
      col:=getxy(round(rad*cos(de-deg))
      ,round(rad*sin(de-deg)));}
      col:=Getpixel(round(x+xp),round(y+yp),ad);
      if col>51 then
        putPixel(round(xp+x),round(yp+y),0,ad);
{      putpixel(xp+x,yp+y,getpixel(xp+x,yp+y,ad2),ad);}
    end;
end;

  procedure CameraCir(camera:Rcamera;x,y,rad:real;num:integer;deg:real;color:byte;ad:word);
  var
   i:integer;
  begin
    for i:=0 to num do
      cameraPixel(camera,x+rad*cos(i/num*2*pi+deg),y+rad*sin(i/num*2*pi+deg),color,ad);
  end;


    procedure firebg(xmin,ymin,xmax,ymax:integer;hic,lowc:byte;vaddr,ad2:word);
  var
    x,y,c,a:integer;
  begin
    for x:=xmin to xmax do for y:=ymax downto ymin do
    begin
      c:=getpixel(x,y,ad2)-1;
      if(c+1>0)and(c<hic) then
      begin
        a:=getpixel(x-1,y,ad2);
        if a>hic then a:=0;
        if random(2)=1 then putpixel(x-1,y,(a+c) shr 1,ad2);
        a:=getpixel(x+1,y,ad2);
        if a>hic then a:=0;
        if random(2)=1 then putpixel(x+1,y,(a+c) shr 1,ad2);
        a:=getpixel(x,y-1,ad2);
        if a>hic then a:=0;
        if random(2)=1 then putpixel(x,y-1,(a+c) shr 1,ad2);
        a:=getpixel(x,y+1,ad2);
        if a>hic then a:=0;
        if random(2)=1 then putpixel(x,y+1,(a+c) shr 1,ad2);
        putpixel(x,y,c,ad2);
{        if getpixel(x,y,ad2)<lowc then putpixel(x,y,getpixel(x,y,vaddr),ad2);
        if getpixel(x-1,y,ad2)<lowc then putpixel(x-1,y,getpixel(x-1,y,vaddr),ad2);
        if getpixel(x+1,y,ad2)<lowc then putpixel(x+1,y,getpixel(x+1,y,vaddr),ad2);
        if getpixel(x,y-1,ad2)<lowc then putpixel(x,y-1,getpixel(x,y-1,vaddr),ad2);
        if getpixel(x,y+1,ad2)<lowc then putpixel(x,y+1,getpixel(x,y+1,vaddr),ad2);}
      end;
    end;
  end;

procedure  repic;
var
 i,j,x,y,length:integer;
 color:byte;
begin
{    for x:=-5 to 5 do for y:=-9 to 8 do
    if(ss[y,x]>12)and(ss[y,x]<>48)then ss[y,x]:=56+abs(x)+random(2);
    for x:=-5 to 5 do for y:=-9 to 8 do
    if(ss[y,x]>0)and(ss[y,x]<13)then ss[y,x]:=80-round(sqrt(x*x+y*y));}
  for i:= 1 to 2000 do
  begin
       x:=random(31-4)-15+2;
       y:=random(31-4)-15+2;
       length:=3;
       color:=random(8)+16*3+3;
       for j:=-length to length do
       begin
         if random(2)=0 then
           setXY(x+j,y,color)
         else
           setXY(x,y+j,color);
       end;
  end;

end;

procedure cir3(x,y:real;rad:integer;color:byte;ad:word);
var
  i,num:integer;
  deg:real;
begin
num:=10;
deg:=x/10+y/2;
for i:=0 to num do
  limpixel(round(x+rad*cos(i/num*2*pi+deg)),round(y+rad*sin(i/num*2*pi+deg)),color,ad);
end;

procedure cir2(x,y,deg:real;rad:integer;color:byte;ad:word);
var
  i,num:integer;
begin
num:=10;
for i:=0 to num do
  limpixel(round(x+rad*cos(i/num*2*pi+deg)),round(y+rad*sin(i/num*2*pi+deg)),color,ad);
end;

  Procedure frame(x1,y1,x2,y2,col:integer;ad_vs:word);
  var
    x,y:integer;
  begin
    flip_only(x1,x2);
    flip_only(y1,y2);
    for x:=x1 to x2 do
    begin
      putPixel(x,y1,col,ad_vs);
      putPixel(x,y2,col,ad_vs);
    end;
    for y:=y1+1 to y2-1 do
    begin
      putPixel(x1,y,col,ad_vs);
      putPixel(x2,y,col,ad_vs);
    end;
  end;





  begin
    repic;
  end.