{$A+ Align all data on word boundaries       }
{$B- Enable short circuit boolean evaluation }
{$D+ Enable debugging information            }
{$E- Disable x87 emmulation                  }
{$F- Do not force far calls                  }
{$G+ Enable 286 instructions                 }
{$I- Disable IO checking                     }
{$O- Disable overlay support                 }
{$Q- Disable overflow checking               }
{$R- Disable range checking                  }
{$S- Disable stack checking                  }
{$T- Disable type checking on pointers       }
{$V- Disable VAR type checking               }
{$X+ Enable Extended syntax                  }
{$Y- Disable symbol reference info           }
{$N+}
Unit sShot;
interface
uses sShotPro,SCTypes,k_sprite,sgun,k_mem;
Const
  MaxShots = 100;
type
  Oshots = object
     private
     Pprof:array[1..MaxShotPro+maxGuns] of POshotsProfile;

     ST:array[1..maxShots] of word;{ObyteArray; {to array}
     x,y,deg:array[1..maxShots] of real;
     sTime:array[1..maxShots] of word;{}
     LifeTime:array[1..maxShots] of word;
{     dispPara:array[1..maxShots] of byte;{to do:dynamecly allocate}

     public
     constructor Cnew;
     procedure open; {open}
     procedure kill;
     procedure SetProfiles(pro:POshotsProfile;ind:byte);

     function getPro(index:byte):byte;
     procedure display(camera:Rcamera;ad:word); {?}
     procedure initShotGun(i:word;iSType:byte;inLifeTime:word;ix,iy,ideg:real);
     procedure initShot(i:word;iSType:byte);
     procedure update(ex,ey,allieX,allieY,myX,myY:real);
     function  impectCheck(ex,ey,esize:real; var fx,fy,EsX,EsY,minDis:real;var impSpec:RimpectData):real;

  end;

implementation
  uses crt,mcga_vs,space_u,K_math,math_unt;
  constructor Oshots.Cnew;
  var
    i:integer;
  begin
{    ST.open(maxShots+1);}
{    lifeTime.open(maxShots+1);}
    for i:=1 to maxShots do
    begin
      x[i]:=0;
      y[i]:=0;
      deg[i]:=0;

      ST[i]:=0;
      sTime[i]:=0;
      LifeTime[i]:=1;
    end;
  end;

  procedure Oshots.open;
  var
    i:integer;
  begin

  end;

  procedure Oshots.kill;
  begin
{    ST.kill;}
{    lifeTime.kill;}
  end;


  function Oshots.getPro(index:byte):byte;
  begin
    getPro:=ST[index]
  end;

  function Oshots.impectCheck(ex,ey,esize:real; var fx,fy,EsX,EsY,minDis:real;var impSpec:RimpectData):real;
  var
    i:integer;
    ShotInd:byte;
    disSqred:real;
  begin
    minDis:=400000;

    fx:=0; fy:=0; impSpec.demege:=0; impSpec.energy:=0; impSpec.control:=0;
    for i:=1 to maxShots do
    if(getPro(i)>0)then {******}
    if(PProf[getPro(i)]^.getPhysical)then
    begin

      disSqred:=sqr(x[i]-ex)+sqr(y[i]-ey);
      if disSqred<minDis then
      begin
        minDis:=disSqred;
        shotInd:=i;
      end;

      if disSqred<sqr(eSize+PProf[getPro(i)]^.getSize(sTime[i],lifeTime[i]))then
      begin
        impSpec.demege:=impSpec.demege+PProf[getPro(i)]^.getDemege(sTime[i],lifeTime[i]);
        impSpec.energy:=impSpec.energy+PProf[getPro(i)]^.getEnergy(sTime[i],lifeTime[i]);
        impSpec.control:=impSpec.control+PProf[getPro(i)]^.getControl(sTime[i],lifeTime[i]);

        fx:=fx+cos(deg[i])*PProf[getPro(i)]^.getForceOnEnemy;
        fy:=fy+sin(deg[i])*PProf[getPro(i)]^.getForceOnEnemy;
        if not(PProf[getPro(i)]^.getPresist) then
          InitShot(i,PProf[getPro(i)]^.transShot(0));
      end
    end;
    if minDis<40000 then {change}
    begin
      EsX:=X[shotInd];
      EsY:=Y[shotInd];
    end
    else  {dose not need to be like thet- fix}
    begin
       EsX:=0;
      EsY:=0;
    end;
    minDis:=sqrt(minDis);
    impectCheck:=impSpec.demege; {????}
  end;

  procedure Oshots.update(ex,ey,allieX,allieY,myX,myY:real);
  var
    i:integer;
  begin
    for i:=1 to maxShots do
    if getPro(i)>0 then
    begin
      PProf[getPro(i)]^.updateShot(ex,ey,allieX,allieY,myX,myY,
        sTime[i],x[i],y[i],deg[i]); {update shot}

      inc(sTime[i]); {increment time}

      if sTime[i]>lifeTime[i] then {transfrom shot when end of life time}
        InitShot(i,PProf[getPro(i)]^.transShot(1)); {1 - for end of life}

    end;

  end;

  procedure Oshots.InitShotGun(i:word;iSType:byte;inLifeTime:word;ix,iy,ideg:real);
  begin
    ST[i]:=iSType;
    if getPro(i)>0 then {*****}
    begin
      lifeTime[i]:=inLifeTime{PProf[getPro(i)]^.getLifeTimeInit};
      sTime[i]:=0;
      deg[i]:=deg[i]+PProf[getPro(i)]^.getDegInit;
      x[i]:=ix;
      y[i]:=iy; {add life time}
      deg[i]:=iDeg;
    end;
  end;

  procedure Oshots.InitShot(i:word;iSType:byte);
  begin
    ST[i]:=iSType;
    sTime[i]:=0;
    if getPro(i)>0 then {*****}
    begin
      lifeTime[i]:=PProf[getPro(i)]^.getLifeTimeInit;
      deg[i]:=deg[i]+PProf[getPro(i)]^.getDegInit
    end
  end;

  procedure Oshots.SetProfiles(pro:POshotsProfile;ind:byte);
  begin
    if ind > MaxShotPro+maxGuns then halt;
    Pprof[ind]:=pro
  end;

  procedure Oshots.display(camera:Rcamera;ad:word);
  var
    i:integer;
  begin
    for i:=1 to maxShots do
    if getPro(i)>0 then
    begin
       PProf[getPro(i)]^.draw(x[i],y[i],deg[i],{dispPara[i]}0,sTime[i],LifeTime[i],camera,ad)
    end
  end;

begin
end.