unit mcga_fil;

interface
type
Otext = object
    public
    VText:pointer;
    ad_text:word;
    size:word;
    StringNum:byte;
    public
    constructor open;
    procedure   Load(FileName:string);
    destructor  Kill;
    function    get(index:byte):string;
  end;
    {Save part of the screen to file_name}
    procedure save_screen(file_name:string;xmin,ymin,xmax,ymax:word;ad:word);
    {Open file to screen at from xmin ymin to xmax ymax}
    procedure open_screen(file_name:string;xmin,ymin,xmax,ymax:word;ad:word);
    {Open very fast form a file to the screen starting from point (0,ymin)}
    procedure block_open(file_name:string;ymin,linenum:word;ad:word);
    procedure block_save(file_name:string;ymin,linenum:word;ad:word);
    {plays a movie from a file}
    procedure Movie_play(filen:string;delay_t:word);
    function  get_mem(var ad:word;size:word):pointer;
    procedure free_mem(ad:word;size:word);
    function  Open_file(filename:string;ad:word):word;
    procedure Save_file(filename:string;size:word;ad:word);
    function stadd(s:string;num:longint;s2:string):string;
    function StFlip(sel:byte;s:string):string;
implementation
uses mcga_vs,crt;

 constructor Otext.open;
 begin
   ad_text:=0;
   stringNum:=0;
 end;

 procedure Otext.Load(FileName:string);
 const
   SAFE = 5;
 var
   FHtxt:text;
   FHbyte:file of byte;
   s:string;
   i:byte;
   pos:word;
 begin
    Assign(FHbyte,FileName);
    Reset(FHbyte);
    size := filesize(FHbyte)+SAFE;
    close(FHbyte);

    Vtext:=get_mem(ad_text,size);
    StringNum:=0;
    pos:=0;
    Assign(FHtxt,FileName);
    Reset(FHtxt);
    readln(FHtxt,s);
    while(pos<size-SAFE)and(s<>'~exit')do
    begin
      inc(StringNum);
      for i:=0 to length(s) do
      if pos+i<size-SAFE then
      mem[ad_text:pos+i]:=ord(s[i]);
      pos:=pos+length(s)+1;
      readln(FHtxt,s);
    end;
    close(FHtxt);
 end;

 destructor  Otext.Kill;
 begin
   if ad_text<>0 then
   FreeMem(Vtext,size);
 end;

 function Otext.get(index:byte):string;
 var
   i:byte;
   pos:word;
 begin
    if(index<StringNum)and(ad_text<>0)then
    begin
      pos:=0;
      for i:=1 to index do
      pos:=pos+mem[ad_text:pos]+1;

      get[0]:=chr(mem[ad_text:pos]);
      for i:=1 to mem[ad_text:pos] do
      get[i]:=chr(mem[ad_text:pos+i]);
    end
    else get:='';
 end;

 procedure save_screen(file_name:string;xmin,ymin,xmax,ymax:word;ad:word);
 var
   xc,yc:word;
   sb:file of byte;
 begin
   Assign(sb,file_name);
   Rewrite(sb);
   for yc:=ymin to ymax do
    for xc:=xmin to xmax do
     write(sb,mem[ad:xc+yc*320]);{to be replaced with getpixel OOP}
   Close(sb);
 end;

 procedure open_screen(file_name:string;xmin,ymin,xmax,ymax:word;ad:word);
 var
   xc,yc:word;
   tmp:byte;
   sb:file of byte;
 begin
   Assign(sb,file_name);
   Reset(sb);
   for yc:=ymin to ymax do
    for xc:=xmin to xmax do
    begin
     read(sb,tmp);{to be replaced with putpixel OOP}
     LimPixel(Xc,Yc,tmp,ad);
    end;
   Close(sb);
 end;

 procedure block_open(file_name:string;ymin,linenum:word;ad:word);
 var
   sb:file;
 begin
   linenum:=linenum div 2;
   Assign(sb,File_name);
   Reset(sb);
   BlockRead(sb,mem[ad:ymin*320],5*linenum);
   Close(sb);
 end;

 procedure block_save(file_name:string;ymin,linenum:word;ad:word);
 var
   sb:file;
 begin
   linenum:=linenum div 2;
   Assign(sb,File_name);
   Rewrite(sb);
   BlockWrite(sb,mem[ad:ymin*320],5*linenum);
   Close(sb);
 end;

  Procedure Movie_play(filen:string;delay_t:word);
  var
    Frame,frame_num:word;
    Sb:file;
  begin
    Frame:=0;
    Assign(sb,filen);
    Reset(sb);
    frame_num:=FileSize(sb) div (500);
    repeat
      inc(frame);
      BlockRead(sb,mem[$a000:0],500);
      delay(Delay_t);
    until(keypressed)or(frame=Frame_num);
    Close(sb);
  end;

    function get_mem(var ad:word;size:word):pointer;
    var
      vm:pointer;
    begin
      GetMem (VM,size);   {allocates the memory for the fonts}
      ad:=seg(VM^);
      get_mem:=VM;
    end;

    procedure free_mem(ad:word;size:word);
    var
      vm:pointer;
    begin
      vm:=addr(mem[ad:0]);
      FreeMem(VM,size);
    end;

    function load_file(filename:string;var ad:word):word;
    var   {function is used to load a font from a file to memory}
       i:integer;
       temp:byte;
       size:word;
       data:file of byte;
       ad_file:word;
       vm:pointer;
    begin
      Assign(data,Filename); {Opening the Font file}
      Reset(data);
      size:=filesize(data); {gets the file size for use in the closing}
      get_mem(ad,size);{allocates the memory for the fonts}
      for i:=0 to size-1 do  {loading the Font Data in to memory from the file}
      begin
        read(data,temp);
        MEM[ad_file:i]:=temp;
      end;
      Close(data);      {Closing file}
      load_file:=size;
    end;

    function open_file(filename:string;ad:word):word;
    var   {function is used to load a font from a file to memory}
       i:integer;
       temp:byte;
       size:word;
       data:file of byte;
    begin
      Assign(data,Filename); {Opening the Font file}
      Reset(data);
      size:=filesize(data); {gets the file size for use in the closing}
      for i:=0 to size-1 do  {loading the Font Data in to memory from the file}
      begin
        read(data,temp);
        MEM[ad:i]:=temp;
      end;
      Close(data);      {Closing file}
      open_file:=size;
    end;

   procedure Save_file(filename:string;size:word;ad:word);
    var   {saves a segment of memory to file}
       i:integer;
       temp:byte;
       data:file of byte;
    begin
      Assign(data,Filename); {Opening the Font file}
      Rewrite(data);
      for i:=0 to size-1 do  {loading the Font Data in to memory from the file}
      begin
        temp:=mem[ad:i];
        write(data,temp);
      end;
      Close(data);      {Closing file}
    end;

   function stadd(s:string;num:longint;s2:string):string;
   var
     temp:string[12];
   begin
     str(num,temp);
     stadd:=Concat(Concat(s,temp),s2);
   end;

   function StFlip(sel:byte;s:string):string;
   var
    ans:string;
    i:integer;
   begin
     ans[0]:=s[0];
     for i:=1 to length(s) do
     begin
       case sel of
        1:ans[length(s)+1-i]:=s[i];
        else  ans[i]:=s[i];
       end;
     end;
     Stflip:=ans;
   end;


begin
end.